Drupal.behaviors.nuxtifyDecouplerPreviewBehaviour = {
  attach: function (context) {
    once(
      'nuxtifyDecouplerPreviewBehaviour',
      'iframe.iframe--autoheight',
      context,
    ).forEach(
      (element) => {
        window.addEventListener('message', (e) => {
          const { data } = e

          if (data?.name === 'setFrameHeight') {
            element.style.height = `${data.height}px`
          }
        })

        element.addEventListener('load', (e) => {
          // If the iframe is still 0px height after 2 seconds,
          // it probably hasn't been able to load correctly.
          // If that happens, we set the height to 300px so the user can see it.
          setTimeout(() => {
            if (element.offsetHeight <= 0) {
              element.style.height = '300px'
            }
          }, 2000)
        })
      }
    )
  }
}
